=== debian/changelog ===
folly (2021.01.04.00-0ubuntu1ppa3~bionic) bionic; urgency=medium

  * Package folly for ubuntu bionic

 -- Bartek Kryza <bkryza@gmail.com>  Tue, 10 Aug 2021 20:15:45 +0200
