=== debian/control ===
Source: folly
Priority: optional
Maintainer: Bartek Kryza <bkryza@gmail.com>
Build-Depends: debhelper (>= 9),
    cmake (>= 3.10),
    pkg-config,
    dh-autoreconf,
    g++,
    automake,
    autoconf,
    autoconf-archive,
    googletest,
    libtool,
    libboost-all-dev,
    libevent-dev,
    libdouble-conversion-dev,
    libgoogle-glog-dev,
    libgflags-dev,
    liblz4-dev,
    liblzma-dev,
    libsnappy-dev,
    libfmt-dev (>= 7.0.1),
    libzstd-dev,
    make,
    zlib1g-dev,
    binutils-dev,
    libjemalloc-dev (>= 5.2.1),
    libssl-dev (>= 1.1.0),
    libiberty-dev
Standards-Version: 3.9.7
Section: libs
Homepage: https://github.com/facebook/folly
Vcs-Git: https://github.com/facebook/folly.git

Package: folly-dev
Section: libdevel
Architecture: amd64
Depends: folly (= ${binary:Version}), ${misc:Depends},
    libdouble-conversion-dev,
    libboost-dev,
    libgflags-dev,
    libjemalloc-dev (>= 5.2.1),
    libssl-dev (>= 1.1.0),
    libgoogle-glog-dev,
    libevent-dev
Description: Facebook Open Source Library - development files


Package: folly
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Facebook Open Source Library
    Folly (acronymed loosely after Facebook Open Source Library) is a library of C++11 components designed with practicality and efficiency in mind. Folly contains a variety of core library components used extensively at Facebook. In particular, it's often a dependency of Facebook's other open source C++ efforts and place where those projects can share code.
