=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
        -DLIB_INSTALL_DIR=lib/x86_64-linux-gnu \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DCMAKE_POSITION_INDEPENDENT_CODE=on \
        -DCMAKE_CXX_STANDARD=14 \
        -DCXX_STD=gnu++1y \
        -DBUILD_SHARED_LIBS=on \
        -DPYTHON_EXTENSIONS=off \
        -DBUILD_TESTS=off

#override_dh_strip:
#	dh_strip --dbgsym-migration='folly-dbg (<< 2020.12.16.00-2~)'
